// /////////////////////////////////////////////////////////////////////////////
// DR DOBB'S CHALLENGES
//
// Filename       : EntityShodan.cpp
// Date           : February 2008
//
// Description    : This file defines the EntityShodan class for the user's
//                  controllable avatar.  Once instantiated, the primary
//                  methods for control are Jump(), Run() and Drop().  The
//                  game loop (via CGame) must check IsDead() to determine
//                  if the player has died.
//
// ///////////////////////////////////////////////////////////////////////////
#pragma once



#include "entity.h"
#include "text.h"






class EntityShodan : public Entity 
{

  public:

    bool                    m_Active;

    int                     m_CurAttackPos;

    float                   m_AttackDelay;


    EntityShodan();
    ~EntityShodan();


    virtual void            OnEvent( const EntityEvent Event, int Param1, int Param2, const std::string& TextParam, Entity* pEntity );

    void                    UpdateTimed( Level& aLevel, float ElapsedTime );

    virtual bool            Hit();

};

