// /////////////////////////////////////////////////////////////////////////////
// DR DOBB'S CHALLENGES
//
// Filename       : EntityBug.cpp
// Date           : February 2008
//
// Description    : This file defines the EntityBug class for the user's
//                  controllable avatar.  Once instantiated, the primary
//                  methods for control are Jump(), Run() and Drop().  The
//                  game loop (via CGame) must check IsDead() to determine
//                  if the player has died.
//
// ///////////////////////////////////////////////////////////////////////////
#pragma once



#include "entity.h"
#include "text.h"






class EntitySub : public Entity 
{

  public:

    float                   m_BubbleDelay;


    EntitySub();
    ~EntitySub();


    virtual void            OnEvent( const EntityEvent Event, int Param1, int Param2, const std::string& TextParam, Entity* pEntity );


    virtual void            UpdateTimed( Level& aLevel, float ElapsedTime );
    virtual void            Update( Level& aLevel );

};

