// /////////////////////////////////////////////////////////////////////////////
// DR DOBB'S CHALLENGES
//
// Filename       : EntitySubShot.cpp
// Date           : February 2008
//
// Description    : This file defines the EntitySubShot class for the user's
//                  controllable avatar.  Once instantiated, the primary
//                  methods for control are Jump(), Run() and Drop().  The
//                  game loop (via CGame) must check IsDead() to determine
//                  if the player has died.
//
// ///////////////////////////////////////////////////////////////////////////
#pragma once



#include "entity.h"
#include "text.h"






class EntitySubShot : public Entity 
{

  public:


    EntitySubShot();
    ~EntitySubShot();


    virtual void            OnEvent( const EntityEvent Event, int Param1, int Param2, const std::string& TextParam, Entity* pEntity );

};

